main()
{
	deepwaters = getentarray("deepwater", "targetname");
	if (deepwaters.size > 0)
	{
		level._effect["deepwater_player"] = loadfx ("fx/water/impact_playerjump_water.efx");
		level._effect["water_hit"] = loadfx ("fx/juno/waterhit_veh.efx");
		level._effect["water_hitafter"] = loadfx ("fx/explosions/grenade_water.efx");
	}
	
	for(i = 0; i < deepwaters.size; i++)
	{
		deepwaters[i] thread deepwater_think();
	}	

	drownwaters = getentarray("deep_water", "targetname");
	for(i = 0; i < drownwaters.size; i++)
	{
		drownwaters[i] thread drownwater_think();
	}	

	hipwaters = getentarray("hipwater", "targetname");
	for(i = 0; i < hipwaters.size; i++)
	{
		hipwaters[i] thread hipwater_think();
	}	

}

deepwater_think()
{
	while (1)
	{
		self waittill ("trigger",other);
		
		if ( isPlayer(other))
		{
			other thread drownwater_shock(self,1000);
		}
		else if (isDefined(other.classname) && other.classname == "script_vehicle" )
		{
			other thread deepwater_kill_vehicle(self);
		}

	}
}

deepwater_kill_vehicle(trigger)
{
	if(isDefined(self.in_deep))
		return;
		
	if (  !isdefined(self getvehicleowner()) )
	{
		self.in_mines = true;
		self playsound ("minefield_click");
	
		wait(.5);
		wait(randomFloat(.5));
	
		if(self istouching(trigger))
		{
			origin = self getorigin();
			org = self.origin;
			range = 25;
			maxdamage = 4000;
			mindamage = 400;
			
			playfx ( level._effect["mine_explosion"], origin);
			radiusDamage(origin, range, maxdamage, mindamage);
			level thread playSoundinSpace ("explo_mine", org);
		}
	}
	
	self waittill("allow explode");
	self.in_deep = undefined;
}

drownwater_think()
{
	while (1)
	{
		self waittill ("trigger",other);		

		if ( isPlayer(other) )
		{
			other thread drownwater_shock(self,5);
		}
		else if (isDefined(other.classname) && other.classname == "script_vehicle" )
		{
			other thread deepwater_kill_vehicle(self); 

		}
		else
		{
			other thread deepwater_kill_vehicle(self);
		}
	}
}

drownwater_shock(trigger,dmg)
{
	if(isDefined(self.drowning) || !isAlive(self) )
	{
		return;
	}
		
	self.drowning = true;
	self playsound ("land_water");

	wait(.5);
	wait(randomFloat(.5));

	if(self istouching(trigger))
	{
		origin = self getorigin();
		org = self.origin;
		strShocktype = "melee"; //or default_mp
		duration = 1;

		playfx ( level._effect["deepwater_player"], (origin + (0,0,60)));

		if(isalive(self))
		{
			wait 0.15;
			self viewkick(10, self.origin);  //Amount should be in the range 0-127, and is normalized "damage".  No damage is done.
			self shellshock(strShocktype, duration);
			self dodamagemod (dmg, origin, "MOD_WATER");
		}

		playfx ( level._effect["deepwater_player"], (origin + (0,0,60)));

		wait 2;
	}
	self.drowning = undefined;
}

hipwater_think()
{
	while (1)
	{
		self waittill ("trigger",other);		

		if ( isPlayer(other) )
		{
			other.directhit = undefined;

			if (other isinvehicle())
			{
				continue;
			}
			else
			{	
				other thread hipwater_stance(self);
			}
		}
		else
		{
			continue;
		}
	}
}

hipwater_stance(trigger)
{
	if(self istouching(trigger))
	{
		self setClientCvar("cl_stance", 0);
	}
	wait 0.5;
}

playSoundinSpace (alias, origin)
{
	org = spawn ("script_model",origin);
	wait 0.05;
	org playsound (alias);
	wait 6;
	org delete();
}