main()
{
	precacheFX();
//	spawnWorldFX();

	level thread scripted_mg42s();

	level thread spawn_boatweps();

	level.mg42_east = [];
	level.mg42_east[0] = (-6070, -1130, -20);
	level.mg42_east[1] = (-6070, -1530, -50);
	level.mg42_east[2] = (-6070, -1930, -80);
	level.mg42_east[3] = (-6070, -2330, -110);
	level.mg42_east[4] = (-6070, -2630, -140);
	level.mg42_east[5] = (-6070, -2930, -150);

	level.mg42_west = [];
	level.mg42_west[0] = (130, -930, -25);
	level.mg42_west[1] = (130, -1330, -50);
	level.mg42_west[2] = (130, -1630, -75);
	level.mg42_west[3] = (130, -2030, -100);
	level.mg42_west[4] = (130, -2430, -125);
	level.mg42_west[5] = (130, -2830, -150);

	level thread playsound_array("whizby", level.mg42_east);
	level thread playsound_array("whizby", level.mg42_west);
}

precacheFX()
{
	precachemodel("xmodel/w_us_mac_50cal_non_b17");

	level._effect["mg_tracer"]		= loadfx("fx/juno/tracer_mg42_scripted.efx");

	level._effect["casemateblowup"]		= loadfx("fx/explosions/explosion1_nolight.efx");
    	level._effect["tankburn"]		= loadfx("fx/fire/medfire.efx");
	level._effect["smoke1"] 		= loadfx("fx/smoke/neuville_smoke1.efx");
	level._effect["fueltank"]		= loadfx("fx/explosions/fueltank_ned.efx");
}

spawnWorldFX()
{
	//Destroyed Vehicles
	maps\mp\_fx::loopfx("tankburn", (-2095, 2983, -103), 0.3);
	maps\mp\_fx::loopfx("smoke1", (-2095, 2983, -123), 0.4);

}

scripted_mg42s()
{
	mg42s = getentarray("script_mg42", "targetname");

	if (mg42s.size > 0)
	{
		for(i = 0; i < mg42s.size; i++)
		{
			mg42s[i] thread scripted_mg42_think();

		}
	}	
}

scripted_mg42_think()
{
	while(1)
	{
		wait (randomfloat(2) + .3);
		playfxontag (level._effect["mg_tracer"], self, "tag_flash");
		self playsound ("mg42_scripted");
	}
}

set_ambient(track, loc)
{
	sound_object = spawn ("script_model",loc);

	sound_object SetContents(0);

	sound_object playloopsound(track);

//	iprintln ("playing ambient track ", track);

}

playsound_array(alias, sarray)
{
	org = spawn ("script_model",(-6070, -1530, -100));
	org show();
//	org SetContents(0);
	
	while(1)
	{
		wait (randomfloat(2));
		loc = randomint(5);

		org.origin = sarray[loc];

		org playsound(alias);
	//	iprintln ("Array element " + loc + " at ORIGIN " + org.origin);

	}
}

///////////////////////////////////////////////////////////////////////////////
//Method for attaching an MG42 Turret to a script model
// 1.2 - Added "precacheTurret( turretinfo )" script command to MP.
// By Daffy
///////////////////////////////////////////////////////////////////////////////

spawn_boatweps()
{ 
   weaponinfo = "mg50cal_tripod_stand_mp";
   weaponmodel = "xmodel/w_us_mac_50cal_non_b17";

//a50cal = spawnTurret ("misc_turret",(-630, -1330, 20),weaponinfo);
//a50cal setmodel(weaponmodel);
//a50cal show();

    boats = getentarray("script_boat", "targetname");

	if (boats.size > 0)
	{
		for(i = 0; i < boats.size; i++)
		{
			origin = boats[i].origin + (0,0,200);
			angles = boats[i].angles;

			boats[i].turretwep = spawnTurret ("misc_turret",origin,weaponinfo);

			boats[i].turretwep.angles = angles;

			boats[i].turretwep setmodel(weaponmodel);
			boats[i].turretwep show();

			boats[i] attach(boats[i].turretwep, "tag_secondary_gun");
		}
	}
	else
		println("NO BOATS FOUND");
}